import java.awt.BasicStroke;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.DisplayMode;
import java.awt.Graphics2D;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.IOException;
import java.util.Scanner;

import javax.swing.JFrame;

import type.lang.UniPanel;

public class Labtest09_Sec01_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * [0 marks] Step 1: Read the following statements. These statements are
		 * based on steps 1-3 from lab 9.2, but are not repeating the steps
		 * exactly. Run this application to see what happens. Answer the
		 * comprehension question #1.
		 */

		JFrame frame = new JFrame("My Frame");
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setVisible(true);

		// the following statements are designed to determine the total amount
		// of screen real estate that is available to this application
		GraphicsEnvironment env = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		GraphicsDevice device = env.getDefaultScreenDevice();
		DisplayMode displayMode = device.getDisplayMode();
		int availableWidth = displayMode.getWidth();
		int availableHeight = displayMode.getHeight();
		// we use the setPreferredSize method here because the layout manager of
		// the JFrame is designed to pay attention to the preferred size
		// attribute of the widget it is meant to lay out. (This is not true of
		// the method
		// setSize(int, int), despite the fact that the name of this method
		// would seem to suggest that it would have such an impact on the layout
		// manager).
		frame.setPreferredSize(new Dimension(availableWidth / 3,
				availableHeight / 2));

		Container content = frame.getContentPane();
		UniPanel panel = new UniPanel();
		content.add(panel);
		frame.pack();

		Graphics2D canvas = panel.getGraphics2D();

		/**
		 * [5 marks] Step 2: In this step, create the three rectangles that are
		 * shown on the left-hand side of the screen shot in figure 9.12. Place
		 * them in approximately the same positions. You do not need to create
		 * the series of rectangles that appear on the right-hand side of the
		 * image. Your mark for your answer to this step will also be based on
		 * the use of good programming practices (hint: what was that about
		 * magic numbers?)
		 */

		int xPos = 10;
		int yPos = 10;
		int buffer = 40;
		int width = 200;
		int height = 100;

		Rectangle2D r = new Rectangle2D.Double(xPos, yPos, width, height);
		canvas.draw(r);
		// panel.repaint(); // can defer and do all repaints at the end
		Rectangle2D r2 = new Rectangle2D.Double(xPos, yPos + height + buffer,
				width, height);
		canvas.fill(r2);
		// panel.repaint(); // can defer and do all repaints at the end
		BasicStroke bs = new BasicStroke(20f);
		canvas.setStroke(bs);
		Shape r3 = new Rectangle2D.Double(xPos + width + buffer, yPos, width,
				height);
		canvas.draw(r3);
		panel.repaint();

	}
}
