import java.awt.BasicStroke;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Scanner;

import javax.swing.JFrame;

import type.lang.UniPanel;

public class Labtest09_Sec01_Part2 {

	/**
	 * @param args
	 * @throws IOException
	 * @throws ClassNotFoundException
	 */
	public static void main(String[] args) throws IOException,
			ClassNotFoundException {

		/**
		 * [4 marks] Step 1: There is a file called "L09-collection1.obj" that
		 * is included in this project and it contains the serialized
		 * representations of several objects. Craft some lines of code that
		 * will create the necessary services so that you can read the first
		 * object from this file (and only the first object - don't read further
		 * into the file). Consult section 9.3.2 for how to deserialize objects
		 * from a file. You don't know the type of the first object, so just
		 * store it in a variable of type Object. When you have read the first
		 * object, print it to System.out. Don't close the ObjectInputStream
		 * because we will read from it some more in the next steps.
		 */

		String filename = "L09-collection1.obj";
		FileInputStream fis = new FileInputStream(filename);
		ObjectInputStream ois = new ObjectInputStream(fis);
		Object obj = ois.readObject();
		System.out.println(obj);

		/**
		 * [3 marks] Step 2: Create an int variable called "numObjects". Write
		 * the statement(s) so that this int variable is assigned the value that
		 * was produced from the object in step 1.
		 * 
		 * ["SHORTCUT" STEP] If you cannot find the solution to this step after
		 * a reasonable amount of time, just assign the value of 2 to the
		 * variable directly and continue on for partial marks.
		 */
		int numObjects = (Integer) obj;
		// or
		int numObjects2 = Integer.parseInt(obj.toString());

		/**
		 * [3 marks] Step 3: the value of the object printed out in the step 1
		 * is actually the number of objects that have been serialized and that
		 * can be safely read from the file "L09-collection1.obj". Implement the
		 * code that will iterate the appropriate number of times and read the
		 * indicated number of serialized objects from the file, one after
		 * another. There are at least two objects that can be read from the
		 * file, so if you did the "SHORTCUT" step in Step 2, then you can still
		 * do this step. You may assume that every object in the file after the
		 * first one (that was read in step 1) is of type Rectangle2D. Store the
		 * objects that have been read in a collection called "theCollection".
		 * The exact choice is left to you, but choose something appropriate.
		 * Test the type of the object before performing the cast.
		 */

		Collection<Rectangle2D> theCollection = new ArrayList<Rectangle2D>();
		for (int i = 0; i < numObjects; i++) {
			Object obj2 = ois.readObject();
			if (obj2 instanceof Rectangle2D) {
				theCollection.add((Rectangle2D) obj2);
			}
		}

		/**
		 * [3 marks] Step 3: iterate over the collection and print the width and
		 * height of every Rectangle2D element contained within it. The choice
		 * of formatting is left to you, but each element should be printed on
		 * its own line.
		 */
		for (Rectangle2D r : theCollection) {
			System.out.println(r.getWidth() + "\t" + r.getHeight());
		}

	}
}
